## mediascanner2 0.115~git20230129.0ea75b2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(mediascanner2 CXX C)

set(MEDIASCANNER_VERSION "0.112")

set(MEDIASCANNER_SOVERSION "4")

set(MEDIASCANNER_LIBVERSION "${MEDIASCANNER_SOVERSION}.${MEDIASCANNER_VERSION}")

if(PROJECT_BINARY_DIR STREQUAL PROJECT_SOURCE_DIR)
  message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")
endif()

option(FULL_WARNINGS "All possible compiler warnings." OFF)
option(ENABLE_TESTS "Enable tests" ON)

include(FindPkgConfig)
pkg_check_modules(MEDIASCANNER_DEPS REQUIRED
  gio-2.0
  gio-unix-2.0
  sqlite3>=3.8.5
)
pkg_check_modules(GST gstreamer-1.0 gstreamer-pbutils-1.0 REQUIRED)
pkg_check_modules(GLIB glib-2.0 REQUIRED)
pkg_check_modules(PIXBUF gdk-pixbuf-2.0 REQUIRED)
pkg_check_modules(EXIF libexif REQUIRED)
pkg_check_modules(TAGLIB taglib REQUIRED)
pkg_check_modules(DBUSCPP dbus-cpp REQUIRED)
pkg_check_modules(APPARMOR libapparmor REQUIRED)
pkg_check_modules(UDISKS udisks2 REQUIRED)
find_package(Threads REQUIRED)
find_package(Qt5Core REQUIRED)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wextra -std=c99")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pedantic -Wextra")
set(CMAKE_CXX_STANDARD 17)
if(${FULL_WARNINGS})
# C does not have any more warning flags.
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Weffc++")
endif()
find_package(CoverageReport)

include(GNUInstallDirs)
set(LIBDIR $CMAKE_INSTALL_LIBDIR)

add_subdirectory(src)

if(ENABLE_TESTS)
  message("Tests enabled")
  enable_testing()
  add_subdirectory(test)
else()
  message(WARNING "Tests disabled")
endif()

# Install pkg-config file
configure_file(mediascanner-2.0.pc.in mediascanner-2.0.pc)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mediascanner-2.0.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# Install SystemD user unit
configure_file(mediascanner-2.0.service.in mediascanner-2.0.service)
install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/mediascanner-2.0.service
  DESTINATION lib/systemd/user
)

enable_coverage_report(
  TARGETS
    mediascanner
    extractor-client
    extractor-backend
    mediascanner-extractor
    scannerstuff
    scannerdaemon
    ms-dbus
    mediascanner-dbus
    mediascanner-qml
    query
    mountwatcher
  FILTER
    ${CMAKE_SOURCE_DIR}/tests/*
    ${CMAKE_BINARY_DIR}/*
  TESTS
    basic
    test_mediastore
    test_metadataextractor
    test_extractorbackend
    test_sqliteutils
    test_mfbuilder
    test_subtreewatcher
    test_volumemanager
    test_dbus
    test_qml
    test_util
)

=== test/CMakeLists.txt ===
find_package(GMock REQUIRED)

set(TEST_LIBS
  ${GTEST_BOTH_LIBRARIES}
)

add_definitions(${MEDIASCANNER_DEPS_CFLAGS} ${GST_CFLAGS} ${DBUSCPP_CFLAGS} -DQT_NO_KEYWORDS)
include_directories(../src)

configure_file(test_config.h.in test_config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

configure_file(
  services/com.canonical.MediaScanner2.service.in
  services/com.canonical.MediaScanner2.service)

configure_file(
  services/com.canonical.MediaScanner2.Extractor.service.in
  services/com.canonical.MediaScanner2.Extractor.service)

add_executable(basic basic.cc)
target_link_libraries(basic mediascanner scannerstuff ${TEST_LIBS})
add_test(basic basic)
# The gvfs modules interfere with the private D-Bus test fixtures
set_tests_properties(basic PROPERTIES
  ENVIRONMENT "GIO_MODULE_DIR=${CMAKE_CURRENT_BINARY_DIR}/modules")

add_executable(test_mediastore test_mediastore.cc ../src/mediascanner/utils.cc)
target_link_libraries(test_mediastore mediascanner ${TEST_LIBS})
add_test(test_mediastore test_mediastore)

add_executable(test_extractorbackend test_extractorbackend.cc)
target_link_libraries(test_extractorbackend extractor-backend ${TEST_LIBS})
add_test(test_extractorbackend test_extractorbackend)

add_executable(test_metadataextractor test_metadataextractor.cc)
target_link_libraries(test_metadataextractor extractor-client ${TEST_LIBS})
add_test(test_metadataextractor test_metadataextractor)
# The gvfs modules interfere with the private D-Bus test fixtures
set_tests_properties(test_metadataextractor PROPERTIES
  ENVIRONMENT "GIO_MODULE_DIR=${CMAKE_CURRENT_BINARY_DIR}/modules")

add_executable(test_subtreewatcher test_subtreewatcher.cc)
target_link_libraries(test_subtreewatcher mediascanner scannerstuff ${TEST_LIBS})
add_test(test_subtreewatcher test_subtreewatcher)
# The gvfs modules interfere with the private D-Bus test fixtures
set_tests_properties(test_subtreewatcher PROPERTIES
  ENVIRONMENT "GIO_MODULE_DIR=${CMAKE_CURRENT_BINARY_DIR}/modules")

add_executable(test_volumemanager test_volumemanager.cc)
target_link_libraries(test_volumemanager mediascanner scannerstuff ${TEST_LIBS})
add_test(test_volumemanager test_volumemanager)
# The gvfs modules interfere with the private D-Bus test fixtures
set_tests_properties(test_volumemanager PROPERTIES
  ENVIRONMENT "GIO_MODULE_DIR=${CMAKE_CURRENT_BINARY_DIR}/modules")

add_executable(test_sqliteutils test_sqliteutils.cc)
target_link_libraries(test_sqliteutils ${TEST_LIBS} ${MEDIASCANNER_DEPS_LDFLAGS})
add_test(test_sqliteutils test_sqliteutils)

add_executable(test_mfbuilder test_mfbuilder.cc)
target_link_libraries(test_mfbuilder ${TEST_LIBS} mediascanner)
add_test(test_mfbuilder test_mfbuilder)

add_executable(test_dbus test_dbus.cc)
target_link_libraries(test_dbus ${TEST_LIBS} mediascanner ms-dbus)
add_test(test_dbus test_dbus)

add_executable(test_qml test_qml.cc)
qt5_use_modules(test_qml QuickTest)
target_link_libraries(test_qml mediascanner)
add_test(test_qml test_qml -import ${CMAKE_BINARY_DIR}/src/qml)
set_tests_properties(test_qml PROPERTIES
  ENVIRONMENT "QT_QPA_PLATFORM=minimal;QT_SELECT=qt5"
  TIMEOUT 600)

add_test(test_qml_dbus test_qml -import ${CMAKE_BINARY_DIR}/src/qml)
set_tests_properties(test_qml_dbus PROPERTIES
  ENVIRONMENT "QT_QPA_PLATFORM=minimal;MEDIASCANNER_USE_DBUS=1;QT_SELECT=qt5"
  TIMEOUT 600)

add_test(test_qml_nodb qmltestrunner -import ${CMAKE_BINARY_DIR}/src/qml -input ${CMAKE_CURRENT_SOURCE_DIR}/test_qml_nodb.qml)
set_tests_properties(test_qml_nodb PROPERTIES
  ENVIRONMENT "QT_QPA_PLATFORM=minimal;QT_SELECT=qt5;MEDIASCANNER_CACHEDIR=${CMAKE_CURRENT_BINARY_DIR}/qml-nodb-cachedir;DBUS_SESSION_BUS_ADDRESS="
  TIMEOUT 600)


add_executable(test_util test_util.cc ../src/mediascanner/utils.cc)
target_link_libraries(test_util ${TEST_LIBS} ${GLIB_LDFLAGS})
add_test(test_util test_util)

=== src/ms-dbus/CMakeLists.txt ===
include_directories(..)
add_definitions(${MEDIASCANNER_CFLAGS} ${DBUSCPP_CFLAGS} ${APPARMOR_CFLAGS})

add_library(ms-dbus STATIC
  dbus-codec.cc
  service-skeleton.cc
  service-stub.cc
  )

# gcc 6 is miscompiling something in dbus-cpp, and disabling
# optimisation makes the problem go away.
#  https://bugs.launchpad.net/ubuntu/+source/mediascanner2/+bug/1621002
set_source_files_properties(dbus-codec.cc PROPERTIES COMPILE_FLAGS "-O0")

target_link_libraries(ms-dbus
  mediascanner
  Threads::Threads
  ${DBUSCPP_LDFLAGS}
  ${APPARMOR_LDFLAGS})
# Compile with -fPIC, since this code is linked into the QML plugin.
set_target_properties(ms-dbus PROPERTIES COMPILE_FLAGS "-fPIC ")

add_executable(mediascanner-dbus
  main.cc
)
target_link_libraries(mediascanner-dbus ms-dbus)
set_target_properties(mediascanner-dbus
  PROPERTIES OUTPUT_NAME "mediascanner-dbus-2.0")

install(
  TARGETS mediascanner-dbus
  RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR}/mediascanner-2.0
)

configure_file(
  com.canonical.MediaScanner2.service.in
  com.canonical.MediaScanner2.service)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/com.canonical.MediaScanner2.service
  DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/services
)

=== src/qml/MediaScanner.0.1/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/src)
add_definitions(${DBUSCPP_CFLAGS} -DQT_NO_KEYWORDS)

set(QML_PLUGIN_DIR "${CMAKE_INSTALL_LIBDIR}/qt5/qml/MediaScanner.0.1")

add_library(mediascanner-qml MODULE
  plugin.cc
  MediaFileWrapper.cc
  MediaStoreWrapper.cc
  StreamingModel.cc
  MediaFileModelBase.cc
  AlbumModelBase.cc
  AlbumsModel.cc
  ArtistsModel.cc
  GenresModel.cc
  SongsModel.cc
  SongsSearchModel.cc
)

set_target_properties(mediascanner-qml PROPERTIES
  AUTOMOC TRUE
  NO_SONAME TRUE)
qt5_use_modules(mediascanner-qml Qml Concurrent DBus)
target_link_libraries(mediascanner-qml mediascanner ms-dbus)

install(
  TARGETS mediascanner-qml
  LIBRARY DESTINATION ${QML_PLUGIN_DIR}
)

file(GLOB QMLFILES
  qmldir
)

add_custom_target(mediascanner-qmlfiles ALL
  COMMAND cp ${QMLFILES} ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS ${QMLFILES}
)

install(
  FILES ${QMLFILES}
  DESTINATION ${QML_PLUGIN_DIR}
)

if(NOT CMAKE_CROSSCOMPILING)
  find_program(qmlplugindump_exe qmlplugindump)
  if(NOT qmlplugindump_exe)
    msg(FATAL_ERROR "Could not locate qmlplugindump.")
  endif()

  # qmlplugindump doesn't run reliably in the CI environment (it seems
  # to be instantiating the types, which fails when there is no media
  # database).  So add a 
  add_custom_target(update-qmltypes
    COMMAND QML2_IMPORT_PATH=${CMAKE_BINARY_DIR}/src/qml ${qmlplugindump_exe} -notrelocatable MediaScanner 0.1 > ${CMAKE_CURRENT_SOURCE_DIR}/plugin.qmltypes
    DEPENDS mediascanner-qml mediascanner-qmlfiles
  )
endif()

install(
  FILES plugin.qmltypes
  DESTINATION ${QML_PLUGIN_DIR}
)

=== debian/changelog ===
mediascanner2 (0.115~git20230129.0ea75b2-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1030241).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 01 Feb 2023 15:16:24 +0100

=== debian/control ===
Source: mediascanner2
Section: libs
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>,
           Marius Gripsgard <marius@ubports.com>,
Build-Depends: cmake,
               cmake-extras (>= 0.10),
               dbus,
               debhelper-compat (= 13),
               google-mock,
               libapparmor-dev,
               libdbus-1-dev,
               libdbus-cpp-dev (>= 4.0.0),
               libexif-dev,
               libglib2.0-dev,
               libgstreamer-plugins-base1.0-dev,
               libgstreamer1.0-dev,
               libgdk-pixbuf2.0-dev,
               libgtest-dev,
               libproperties-cpp-dev,
               libsqlite3-dev (>= 3.8.5),
               libtag1-dev,
               libudisks2-dev,
               qml-module-qtquick2,
               qml-module-qttest,
               qtbase5-dev,
               qtbase5-dev-tools,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               dh-apparmor,
# For running unit tests
               gstreamer1.0-plugins-base,
               gstreamer1.0-plugins-good,
               shared-mime-info,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/mediascanner2
Vcs-Git: https://gitlab.com/ubports/development/core/mediascanner2.git
Vcs-Browser: https://gitlab.com/ubports/development/core/mediascanner2

Package: libmediascanner-2.0-4
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Recommends: mediascanner2.0
Description: Access library for the media scanner's index
 This library provides convenient and safe access to the media scanner's
 index files.

Package: mediascanner2.0
Section: misc
Architecture: any
Multi-Arch: foreign
Depends: gstreamer1.0-plugins-base,
         gstreamer1.0-plugins-good,
         dbus,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Media Scanner 2.0
 Media Scanner 2.0 is a user session D-Bus services that scans files (and
 etects changes) in the user's home directory relevant for media apps
 (such as the gallery app, the music player app, the mediaplayer app,
 etc.).
 .
 This package provides the media scanner D-Bus service.

Package: libmediascanner-2.0-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmediascanner-2.0-4 (= ${binary:Version}),
         libsqlite3-dev,
         libglib2.0-dev,
         ${misc:Depends},
Description: Development files for libmediascanner
 Media Scanner 2.0 is a user session D-Bus services that scans files (and
 etects changes) in the user's home directory relevant for media apps
 (such as the gallery app, the music player app, the mediaplayer app,
 etc.).
 .
 This package provides the infrastructure for using the media scanner's
 access library in C++ based projects.

Package: qml-module-mediascanner
Architecture: any
Multi-Arch: same
Depends: mediascanner2.0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: QML plugin for the Media Scanner
 Media Scanner 2.0 is a user session D-Bus services that scans files (and
 etects changes) in the user's home directory relevant for media apps
 (such as the gallery app, the music player app, the mediaplayer app,
 etc.).
 .
 This package provides components that allow access to the media
 scanner index from Qt Quick 2 / QML applications.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/default.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export DPKG_GENSYMBOLS_CHECK_LEVEL=1

# http://ccache.samba.org/manual.html#_precompiled_headers
export CCACHE_SLOPPINESS=time_macros

%:
	dh $@

#ifneq (,$(filter powerpc,$(DEB_HOST_ARCH)))
#  test_arg = || :
#else
#  test_arg =
#endif

override_dh_auto_test:
# Disable unit tests for now, they freeze in tsts_albumsmodel.qml
# Issue needs to be addressed upstream: https://gitlab.com/ubports/development/core/mediascanner2/-/issues/6
#	dh_auto_test --max-parallel=1 -- ARGS="--verbose" $(test_arg)

override_dh_installdeb:
	dh_apparmor --profile-name=usr.bin.mediascanner-service-2.0 -pmediascanner2.0
	dh_apparmor --profile-name=usr.lib.mediascanner-2.0.mediascanner-extractor -pmediascanner2.0
	dh_installdeb

override_dh_install:
	# silence lintian, complaining about empty dirs in package otherwise
	mkdir -p debian/tmp/usr/share/apparmor/hardware/audio.d/
	mkdir -p debian/tmp/usr/share/apparmor/hardware/graphics.d/
	mkdir -p debian/tmp/usr/share/apparmor/hardware/video.d/
	touch debian/tmp/usr/share/apparmor/hardware/audio.d/.placeholder
	touch debian/tmp/usr/share/apparmor/hardware/graphics.d/.placeholder
	touch debian/tmp/usr/share/apparmor/hardware/video.d/.placeholder
	dh_install

override_dh_missing:
	dh_missing --fail-missing

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none,  pretty=0.115~git%cd.%h" \
https://gitlab.com/ubports/development/core/mediascanner2 \
HEAD debian uupdate

## mediascanner2 0.115

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,9 @@
-cmake_minimum_required(VERSION 3.0.2)
-project(mediascanner2 CXX C)
+cmake_minimum_required(VERSION 3.6.0)
+project(mediascanner2 VERSION 0.115 LANGUAGES CXX C)
 
-set(MEDIASCANNER_VERSION "0.112")
+set(MEDIASCANNER_VERSION "${PROJECT_VERSION}")
 
 set(MEDIASCANNER_SOVERSION "4")
-
 set(MEDIASCANNER_LIBVERSION "${MEDIASCANNER_SOVERSION}.${MEDIASCANNER_VERSION}")
 
 if(PROJECT_BINARY_DIR STREQUAL PROJECT_SOURCE_DIR)
@@ -15,6 +14,7 @@
 option(ENABLE_TESTS "Enable tests" ON)
 
 include(FindPkgConfig)
+find_package(PkgConfig REQUIRED)
 pkg_check_modules(MEDIASCANNER_DEPS REQUIRED
   gio-2.0
   gio-unix-2.0
@@ -25,15 +25,16 @@
 pkg_check_modules(PIXBUF gdk-pixbuf-2.0 REQUIRED)
 pkg_check_modules(EXIF libexif REQUIRED)
 pkg_check_modules(TAGLIB taglib REQUIRED)
-pkg_check_modules(DBUSCPP dbus-cpp REQUIRED)
+pkg_check_modules(DBUSCPP dbus-cpp REQUIRED IMPORTED_TARGET)
 pkg_check_modules(APPARMOR libapparmor REQUIRED)
 pkg_check_modules(UDISKS udisks2 REQUIRED)
 find_package(Threads REQUIRED)
-find_package(Qt5Core REQUIRED)
+find_package(Qt5 "5.12.0" COMPONENTS Core Test QuickTest Qml Concurrent DBus REQUIRED)
 
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wextra -std=c99")
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pedantic -Wextra")
 set(CMAKE_CXX_STANDARD 17)
+
 if(${FULL_WARNINGS})
 # C does not have any more warning flags.
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Weffc++")

=== src/CMakeLists.txt ===
add_subdirectory(mediascanner)
add_subdirectory(extractor)
add_subdirectory(daemon)
add_subdirectory(ms-dbus)
add_subdirectory(qml/MediaScanner.0.1)
add_subdirectory(utils)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -67,8 +67,10 @@
 add_test(test_dbus test_dbus)
 
 add_executable(test_qml test_qml.cc)
-qt5_use_modules(test_qml QuickTest)
-target_link_libraries(test_qml mediascanner)
+target_link_libraries(test_qml
+        mediascanner
+        Qt5::Test
+        Qt5::QuickTest)
 add_test(test_qml test_qml -import ${CMAKE_BINARY_DIR}/src/qml)
 set_tests_properties(test_qml PROPERTIES
   ENVIRONMENT "QT_QPA_PLATFORM=minimal;QT_SELECT=qt5"

=== src/daemon/CMakeLists.txt ===
add_definitions(${MEDIASCANNER_DEPS_CFLAGS} ${UDISKS_CFLAGS})
include_directories(..)

add_library(scannerstuff STATIC
  InvalidationSender.cc
  MountWatcher.cc
  VolumeManager.cc
  SubtreeWatcher.cc
  Scanner.cc
  ../mediascanner/utils.cc
)

target_link_libraries(scannerstuff extractor-client ${UDISKS_LDFLAGS})

add_executable(scannerdaemon
  scannerdaemon.cc
)

set_target_properties(scannerdaemon
  PROPERTIES OUTPUT_NAME "mediascanner-service-2.0")

target_link_libraries(scannerdaemon
  mediascanner
  scannerstuff
)

install(
  TARGETS scannerdaemon
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== src/extractor/CMakeLists.txt ===

add_definitions(${MEDIASCANNER_DEPS_CFLAGS} ${GST_CFLAGS} ${EXIF_CFLAGS} ${PIXBUF_CFLAGS} ${TAGLIB_CFLAGS})
include_directories(.. ${CMAKE_CURRENT_BINARY_DIR})

# Build stubs/skeletons for D-Bus interface
find_program(gdbus_codegen gdbus-codegen)
if(NOT gdbus_codegen)
  msg(FATAL_ERROR "Could not locate gdbus-codegen")
endif()

add_custom_command(
  OUTPUT dbus-generated.c dbus-generated.h
  COMMAND ${gdbus_codegen} --interface-prefix=com.canonical.MediaScanner2 --generate-c-code dbus-generated --c-namespace MS ${CMAKE_CURRENT_SOURCE_DIR}/dbus-interface.xml
  MAIN_DEPENDENCY dbus-interface.xml
  )
# Code generated by gdbus-codegen doesn't like all the warning flags
# we have turned on.
set_property(SOURCE dbus-generated.c APPEND_STRING PROPERTY
  COMPILE_FLAGS " -Wno-unused-parameter -Wno-pedantic")

# The client code for the extractor daemon
add_library(extractor-client STATIC
  MetadataExtractor.cc
  dbus-generated.c
  dbus-marshal.cc
  ../mediascanner/utils.cc
)
target_link_libraries(extractor-client
  mediascanner
)

# The backend code for the extractor daemon, as a library for use by tests
add_library(extractor-backend STATIC
  ExtractorBackend.cc
  GStreamerExtractor.cc
  ImageExtractor.cc
  TaglibExtractor.cc
)
target_link_libraries(extractor-backend
  extractor-client
  ${GST_LDFLAGS}
  ${EXIF_LDFLAGS}
  ${PIXBUF_LDFLAGS}
  ${TAGLIB_LDFLAGS}
)

add_executable(mediascanner-extractor
  main.cc
)
target_link_libraries(mediascanner-extractor extractor-backend)

install(
  TARGETS mediascanner-extractor
  RUNTIME DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/mediascanner-2.0
)

configure_file(
  com.canonical.MediaScanner2.Extractor.service.in
  com.canonical.MediaScanner2.Extractor.service)
install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/com.canonical.MediaScanner2.Extractor.service
  DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/services
)

=== src/ms-dbus/CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 
 install(
   TARGETS mediascanner-dbus
-  RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR}/mediascanner-2.0
+  RUNTIME DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/mediascanner-2.0
 )
 
 configure_file(

=== src/utils/CMakeLists.txt ===
add_definitions(${MEDIASCANNER_DEPS_CFLAGS})
include_directories(..)

add_executable(watcher watchertest.cc)

add_executable(query query.cc)
target_link_libraries(query mediascanner
${MEDIASCANNER_DEPS_LDFLAGS})

add_executable(mountwatcher mountwatcher.cc)
target_link_libraries(mountwatcher scannerstuff)

=== debian/changelog ===
mediascanner2 (0.115-4build4) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 12 Apr 2024 05:40:18 +0000

mediascanner2 (0.115-4build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 20:05:53 +0000

mediascanner2 (0.115-4build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 05:54:33 +0000

mediascanner2 (0.115-4build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:44:07 +0000

mediascanner2 (0.115-4) unstable; urgency=medium

  * d/control: Use my debian email
  * d/control: replace B-D libgdk-pixbuf2.0-dev with
    libgdk-pixbuf-2.0-dev (closes: #1037395)

 -- Marius Gripsgard <mariogrip@debian.org>  Sun, 29 Oct 2023 16:14:15 +0100

mediascanner2 (0.115-3) unstable; urgency=medium

  * debian/:
    + Don't ship apparmor .placeholder files, only ship the empty directories.
      (Closes: #1030699).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 06 Feb 2023 18:49:14 +0100

mediascanner2 (0.115-2) unstable; urgency=medium

  * debian/control:
    + Fix Vcs-*: fields. Point to Salsa, not to upstream's GitLab.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 06 Feb 2023 15:35:30 +0100

mediascanner2 (0.115-1) unstable; urgency=medium

  * New upstream release.
  * debian/watch:
    + Start watching upstream releases.
  * debian/patches:
    + Drop 1001_use-libexecdir.patch. Applied upstream.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
  * debian/rules:
    + Re-enable unit-tests. They are now fixed and work like a charme. (Thanks
      to Sergey Chuplign).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 04 Feb 2023 23:06:44 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: mediascanner2
 Section: libs
 Priority: optional
-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders: Mike Gabriel <sunweaver@debian.org>,
-           Marius Gripsgard <marius@ubports.com>,
+           Marius Gripsgard <marius@debian.org>,
 Build-Depends: cmake,
                cmake-extras (>= 0.10),
                dbus,
@@ -16,7 +17,7 @@
                libglib2.0-dev,
                libgstreamer-plugins-base1.0-dev,
                libgstreamer1.0-dev,
-               libgdk-pixbuf2.0-dev,
+               libgdk-pixbuf-2.0-dev,
                libgtest-dev,
                libproperties-cpp-dev,
                libsqlite3-dev (>= 3.8.5),
@@ -36,8 +37,8 @@
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/core/mediascanner2
-Vcs-Git: https://gitlab.com/ubports/development/core/mediascanner2.git
-Vcs-Browser: https://gitlab.com/ubports/development/core/mediascanner2
+Vcs-Git: https://salsa.debian.org/ubports-team/mediascanner2.git
+Vcs-Browser: https://salsa.debian.org/ubports-team/mediascanner2
 
 Package: libmediascanner-2.0-4
 Architecture: any

=== debian/watch ===
version=4
https://gitlab.com/ubports/development/core/mediascanner2/tags .*/mediascanner2-(\d\S+)\.tar\.gz

## mediascanner2 0.117

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.6.0)
-project(mediascanner2 VERSION 0.115 LANGUAGES CXX C)
+project(mediascanner2 VERSION 0.117 LANGUAGES CXX C)
 
 set(MEDIASCANNER_VERSION "${PROJECT_VERSION}")
 
@@ -13,9 +13,13 @@
 option(FULL_WARNINGS "All possible compiler warnings." OFF)
 option(ENABLE_TESTS "Enable tests" ON)
 
+# Add a CMake variable for debug mode
+option(DEBUG_MODE "Enable debug mode" OFF)
+
 include(FindPkgConfig)
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(MEDIASCANNER_DEPS REQUIRED
+  glib-2.0
   gio-2.0
   gio-unix-2.0
   sqlite3>=3.8.5

=== src/extractor/CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
 
 add_custom_command(
   OUTPUT dbus-generated.c dbus-generated.h
-  COMMAND ${gdbus_codegen} --interface-prefix=com.canonical.MediaScanner2 --generate-c-code dbus-generated --c-namespace MS ${CMAKE_CURRENT_SOURCE_DIR}/dbus-interface.xml
+  COMMAND ${gdbus_codegen} --interface-prefix=com.lomiri.MediaScanner2 --generate-c-code dbus-generated --c-namespace MS ${CMAKE_CURRENT_SOURCE_DIR}/dbus-interface.xml
   MAIN_DEPENDENCY dbus-interface.xml
   )
 # Code generated by gdbus-codegen doesn't like all the warning flags
@@ -36,6 +36,8 @@
   ImageExtractor.cc
   TaglibExtractor.cc
 )
+target_compile_definitions(extractor-backend
+  PRIVATE G_LOG_DOMAIN="mediascanner-extractor")
 target_link_libraries(extractor-backend
   extractor-client
   ${GST_LDFLAGS}
@@ -48,6 +50,8 @@
   main.cc
 )
 target_link_libraries(mediascanner-extractor extractor-backend)
+target_compile_definitions(mediascanner-extractor
+  PRIVATE G_LOG_DOMAIN="mediascanner-extractor")
 
 install(
   TARGETS mediascanner-extractor
@@ -55,9 +59,9 @@
 )
 
 configure_file(
-  com.canonical.MediaScanner2.Extractor.service.in
-  com.canonical.MediaScanner2.Extractor.service)
+  com.lomiri.MediaScanner2.Extractor.service.in
+  com.lomiri.MediaScanner2.Extractor.service)
 install(
-  FILES ${CMAKE_CURRENT_BINARY_DIR}/com.canonical.MediaScanner2.Extractor.service
+  FILES ${CMAKE_CURRENT_BINARY_DIR}/com.lomiri.MediaScanner2.Extractor.service
   DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/services
 )

=== src/mediascanner/CMakeLists.txt ===
add_library(mediascanner SHARED
  MediaFile.cc
  MediaFileBuilder.cc
  MediaFilePrivate.cc
  Filter.cc
  Album.cc
  MediaStore.cc
  MediaStoreBase.cc
  FolderArtCache.cc
  utils.cc
  mozilla/fts3_porter.c
  mozilla/Normalize.c
)

set(symbol_map "${CMAKE_CURRENT_SOURCE_DIR}/mediascanner-2.0.map")
set_target_properties(mediascanner PROPERTIES
    LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map} ")
set_target_properties(mediascanner PROPERTIES LINK_DEPENDS ${symbol_map})

add_definitions(${MEDIASCANNER_DEPS_CFLAGS})
target_compile_definitions(mediascanner
  PRIVATE G_LOG_DOMAIN="mediascanner")
target_link_libraries(mediascanner ${MEDIASCANNER_DEPS_LDFLAGS})

set_target_properties(mediascanner PROPERTIES
  OUTPUT_NAME "mediascanner-2.0"
  SOVERSION ${MEDIASCANNER_SOVERSION}
  VERSION ${MEDIASCANNER_LIBVERSION}
)

install(
  TARGETS mediascanner
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(FILES
  Album.hh
  Filter.hh
  MediaFile.hh
  MediaFileBuilder.hh
  MediaStore.hh
  MediaStoreBase.hh
  scannercore.hh
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/mediascanner-2.0/mediascanner"
)

=== src/utils/CMakeLists.txt ===
add_definitions(${MEDIASCANNER_DEPS_CFLAGS})
include_directories(..)

add_executable(mediascanner-watcher watchertest.cc)
install(
  TARGETS mediascanner-watcher
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

add_executable(mediascanner-query query.cc)
target_link_libraries(mediascanner-query mediascanner
${MEDIASCANNER_DEPS_LDFLAGS})
install(
  TARGETS mediascanner-query
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

add_executable(mediascanner-mountwatcher mountwatcher.cc)
target_link_libraries(mediascanner-mountwatcher scannerstuff)
install(
  TARGETS mediascanner-mountwatcher
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== debian/changelog ===
mediascanner2 (0.117-3) unstable; urgency=medium

  * debian/control:
    + Switch from libtag1-dev to libtag-dev (as part of the taglib 2.x
      transition).
  * debian/patches:
    + Add 1001_taglib-2.x.patch. Support building against taglib 2.x. (Closes:
      #1092684).
  * debian/copyright:
    + Update attributions for debian/.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 11 Jan 2025 17:49:11 +0100

mediascanner2 (0.117-2) unstable; urgency=medium

  * Re-upload source-only as is.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 12 Oct 2024 15:16:37 +0200

mediascanner2 (0.117-1) unstable; urgency=medium

  * New upstream release.
  * debian/: Add bin:pkg mediascanner2.0-utils.
  * debian/patches:
    + Drop 1001_only-start-with-lomiri.patch. Similar change applied upstream.
    + Add 1001_typo-fixes.patch. Typo fixing.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 10 Oct 2024 19:23:38 +0200

mediascanner2 (0.116-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump Standards-Version: to 4.7.0. No changes needed.
  * debian/patches:
    + Add 1001_only-start-with-lomiri.patch. Only start Mediascanner-2.0 in
      Lomiri sessions.
  * debian/copyright:
    + Update copyright attribution for debian/.
  * debian/source/lintian-overrides:
    + Drop very-long-line-length-in-source-file overrides.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 08 Oct 2024 09:36:47 +0200

mediascanner2 (0.115-5) unstable; urgency=medium

  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 08 Jul 2024 09:11:15 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: mediascanner2
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders: Mike Gabriel <sunweaver@debian.org>,
            Marius Gripsgard <marius@debian.org>,
 Build-Depends: cmake,
@@ -21,7 +20,7 @@
                libgtest-dev,
                libproperties-cpp-dev,
                libsqlite3-dev (>= 3.8.5),
-               libtag1-dev,
+               libtag-dev,
                libudisks2-dev,
                qml-module-qtquick2,
                qml-module-qttest,
@@ -34,7 +33,7 @@
                gstreamer1.0-plugins-base,
                gstreamer1.0-plugins-good,
                shared-mime-info,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/core/mediascanner2
 Vcs-Git: https://salsa.debian.org/ubports-team/mediascanner2.git
@@ -67,6 +66,22 @@
  .
  This package provides the media scanner D-Bus service.
 
+Package: mediascanner2.0-utils
+Section: misc
+Architecture: any
+Multi-Arch: foreign
+Pre-Depends: ${misc:Pre-Depends},
+Depends: mediascanner2.0 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends},
+Description: Media scanner utilities
+ Media Scanner 2.0 is a user session D-Bus services that scans files (and
+ etects changes) in the user's home directory relevant for media apps
+ (such as the gallery app, the music player app, the mediaplayer app,
+ etc.).
+ .
+ This package provides the media scanner utilities for testing and debugging.
+
 Package: libmediascanner-2.0-dev
 Section: libdevel
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/default.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export DPKG_GENSYMBOLS_CHECK_LEVEL=1

# http://ccache.samba.org/manual.html#_precompiled_headers
export CCACHE_SLOPPINESS=time_macros

%:
	dh $@

ifneq (,$(filter powerpc,$(DEB_HOST_ARCH)))
  test_arg = || :
else
  test_arg =
endif

override_dh_auto_test:
	dh_auto_test --max-parallel=1 -- ARGS="--verbose" $(test_arg)

override_dh_installdeb:
	dh_apparmor --profile-name=usr.bin.mediascanner-service-2.0 -pmediascanner2.0
	dh_apparmor --profile-name=usr.lib.mediascanner-2.0.mediascanner-extractor -pmediascanner2.0
	dh_installdeb

override_dh_missing:
	dh_missing --fail-missing

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

## mediascanner2 0.118

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.6.0)
-project(mediascanner2 VERSION 0.117 LANGUAGES CXX C)
+project(mediascanner2 VERSION 0.118 LANGUAGES CXX C)
 
 set(MEDIASCANNER_VERSION "${PROJECT_VERSION}")

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -11,12 +11,12 @@
 include_directories(${CMAKE_CURRENT_BINARY_DIR})
 
 configure_file(
-  services/com.canonical.MediaScanner2.service.in
-  services/com.canonical.MediaScanner2.service)
+  services/com.lomiri.MediaScanner2.service.in
+  services/com.lomiri.MediaScanner2.service)
 
 configure_file(
-  services/com.canonical.MediaScanner2.Extractor.service.in
-  services/com.canonical.MediaScanner2.Extractor.service)
+  services/com.lomiri.MediaScanner2.Extractor.service.in
+  services/com.lomiri.MediaScanner2.Extractor.service)
 
 add_executable(basic basic.cc)
 target_link_libraries(basic mediascanner scannerstuff ${TEST_LIBS})

=== src/daemon/CMakeLists.txt ===
--- 
+++ 
@@ -19,6 +19,9 @@
 set_target_properties(scannerdaemon
   PROPERTIES OUTPUT_NAME "mediascanner-service-2.0")
 
+target_compile_definitions(scannerdaemon
+  PRIVATE G_LOG_DOMAIN="mediascanner-service-2.0")
+
 target_link_libraries(scannerdaemon
   mediascanner
   scannerstuff

=== src/ms-dbus/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 include_directories(..)
-add_definitions(${MEDIASCANNER_CFLAGS} ${DBUSCPP_CFLAGS} ${APPARMOR_CFLAGS})
+add_definitions(${MEDIASCANNER_CFLAGS} ${DBUSCPP_CFLAGS} ${APPARMOR_CFLAGS} ${GLIB_CFLAGS})
 
 add_library(ms-dbus STATIC
   dbus-codec.cc
@@ -16,13 +16,16 @@
   mediascanner
   Threads::Threads
   ${DBUSCPP_LDFLAGS}
-  ${APPARMOR_LDFLAGS})
+  ${APPARMOR_LDFLAGS}
+  ${GLIB_LDFLAGS})
 # Compile with -fPIC, since this code is linked into the QML plugin.
 set_target_properties(ms-dbus PROPERTIES COMPILE_FLAGS "-fPIC ")
 
 add_executable(mediascanner-dbus
   main.cc
 )
+target_compile_definitions(mediascanner-dbus
+  PRIVATE G_LOG_DOMAIN="mediascanner-dbus-2.0")
 target_link_libraries(mediascanner-dbus ms-dbus)
 set_target_properties(mediascanner-dbus
   PROPERTIES OUTPUT_NAME "mediascanner-dbus-2.0")
@@ -33,10 +36,10 @@
 )
 
 configure_file(
-  com.canonical.MediaScanner2.service.in
-  com.canonical.MediaScanner2.service)
+  com.lomiri.MediaScanner2.service.in
+  com.lomiri.MediaScanner2.service)
 
 install(
-  FILES ${CMAKE_CURRENT_BINARY_DIR}/com.canonical.MediaScanner2.service
+  FILES ${CMAKE_CURRENT_BINARY_DIR}/com.lomiri.MediaScanner2.service
   DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/services
 )

=== src/utils/CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,10 @@
 add_definitions(${MEDIASCANNER_DEPS_CFLAGS})
 include_directories(..)
 
-add_executable(mediascanner-watcher watchertest.cc)
 install(
-  TARGETS mediascanner-watcher
-  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+  PROGRAMS watchertest.sh
+  DESTINATION ${CMAKE_INSTALL_BINDIR}
+  RENAME mediascanner-watcher
 )
 
 add_executable(mediascanner-query query.cc)

=== src/qml/MediaScanner.0.1/CMakeLists.txt ===
--- 
+++ 
@@ -1,27 +1,43 @@
 include_directories(${CMAKE_SOURCE_DIR}/src)
-add_definitions(${DBUSCPP_CFLAGS} -DQT_NO_KEYWORDS)
+
+set(CMAKE_AUTOMOC ON)
+set(CMAKE_AUTORCC ON)
 
 set(QML_PLUGIN_DIR "${CMAKE_INSTALL_LIBDIR}/qt5/qml/MediaScanner.0.1")
 
-add_library(mediascanner-qml MODULE
-  plugin.cc
-  MediaFileWrapper.cc
-  MediaStoreWrapper.cc
-  StreamingModel.cc
-  MediaFileModelBase.cc
-  AlbumModelBase.cc
-  AlbumsModel.cc
-  ArtistsModel.cc
-  GenresModel.cc
-  SongsModel.cc
-  SongsSearchModel.cc
+add_library(mediascanner-qml SHARED
+  plugin.cpp
+  MediaFileWrapper.cpp
+  MediaFileWrapper.h
+  MediaStoreWrapper.cpp
+  MediaStoreWrapper.h
+  StreamingModel.cpp
+  StreamingModel.h
+  MediaFileModelBase.cpp
+  MediaFileModelBase.h
+  AlbumModelBase.cpp
+  AlbumModelBase.h
+  AlbumsModel.cpp
+  AlbumsModel.h
+  ArtistsModel.cpp
+  ArtistsModel.h
+  GenresModel.cpp
+  GenresModel.h
+  SongsModel.cpp
+  SongsModel.h
+  SongsSearchModel.cpp
+  SongsSearchModel.h
 )
-
-set_target_properties(mediascanner-qml PROPERTIES
-  AUTOMOC TRUE
-  NO_SONAME TRUE)
-qt5_use_modules(mediascanner-qml Qml Concurrent DBus)
-target_link_libraries(mediascanner-qml mediascanner ms-dbus)
+target_compile_definitions(mediascanner-qml PRIVATE -DQT_NO_KEYWORDS)
+target_link_libraries(mediascanner-qml
+    Qt5::Core
+    Qt5::Gui
+    Qt5::Qml
+    Qt5::Concurrent
+    Qt5::DBus
+    PkgConfig::DBUSCPP
+    mediascanner
+    ms-dbus)
 
 install(
   TARGETS mediascanner-qml

=== debian/changelog ===
mediascanner2 (0.118-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.
  * debian/patches:
    + Drop 1001_taglib-2.x.patch and 1001_typo-fixes.patch. Both applied
      upstream.
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 05 May 2025 17:27:22 +0200

=== debian/control ===
--- 
+++ 
@@ -33,7 +33,7 @@
                gstreamer1.0-plugins-base,
                gstreamer1.0-plugins-good,
                shared-mime-info,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/core/mediascanner2
 Vcs-Git: https://salsa.debian.org/ubports-team/mediascanner2.git
